com.opensymphony.xwork2.interceptor
public class: I18nInterceptor [javadoc |
source]
java.lang.Object
com.opensymphony.xwork2.interceptor.AbstractInterceptor
com.opensymphony.xwork2.interceptor.I18nInterceptor
All Implemented Interfaces:
Interceptor
An interceptor that handles setting the locale specified in a session as the locale for the current action request.
In addition, this interceptor will look for a specific HTTP request parameter and set the locale to whatever value is
provided. This means that this interceptor can be used to allow for your application to dynamically change the locale
for the user's session. This is very useful for applications that require multi-lingual support and want the user to
be able to set his or her language preference at any point. The locale parameter is removed during the execution of
this interceptor, ensuring that properties aren't set on an action (such as request_locale) that have no typical
corresponding setter in your action.
For example, using the default parameter name, a request to
foo.action?request_locale=en_US, then the
locale for US English is saved in the user's session and will be used for all future requests.
Interceptor parameters:
- parameterName (optional) - the name of the HTTP request parameter that dictates the locale to switch to and save
in the session. By default this is request_locale
- attributeName (optional) - the name of the session key to store the selected locale. By default this is
WW_TRANS_I18N_LOCALE
Extending the interceptor:
There are no known extensions points for this interceptor.
Example code:
<action name="someAction" class="com.examples.SomeAction">
<interceptor-ref name="i18n"/>
<interceptor-ref name="basicStack"/>
<result name="success">good_result.ftl</result>
</action>
- author:
Aleksei - Gopachenko
| Field Summary |
|---|
| protected static final Logger | LOG | |
| public static final String | DEFAULT_SESSION_ATTRIBUTE | |
| public static final String | DEFAULT_PARAMETER | |
| protected String | parameterName | |
| protected String | attributeName | |
| Method from com.opensymphony.xwork2.interceptor.I18nInterceptor Detail: |
public String intercept(ActionInvocation invocation) throws Exception {
if (LOG.isDebugEnabled()) {
LOG.debug("intercept '"
+ invocation.getProxy().getNamespace() + "/"
+ invocation.getProxy().getActionName() + "' { ");
}
//get requested locale
Map params = invocation.getInvocationContext().getParameters();
Object requested_locale = params.remove(parameterName);
if (requested_locale != null && requested_locale.getClass().isArray()
&& ((Object[]) requested_locale).length == 1) {
requested_locale = ((Object[]) requested_locale)[0];
}
if (LOG.isDebugEnabled()) {
LOG.debug("requested_locale=" + requested_locale);
}
//save it in session
Map session = invocation.getInvocationContext().getSession();
if (session != null) {
if (requested_locale != null) {
Locale locale = (requested_locale instanceof Locale) ?
(Locale) requested_locale : LocalizedTextUtil.localeFromString(requested_locale.toString(), null);
if (LOG.isDebugEnabled()) {
LOG.debug("store locale=" + locale);
}
if (locale != null) {
session.put(attributeName, locale);
}
}
//set locale for action
Object locale = session.get(attributeName);
if (locale != null && locale instanceof Locale) {
if (LOG.isDebugEnabled()) {
LOG.debug("apply locale=" + locale);
}
saveLocale(invocation, (Locale)locale);
}
}
if (LOG.isDebugEnabled()) {
LOG.debug("before Locale=" + invocation.getStack().findValue("locale"));
}
final String result = invocation.invoke();
if (LOG.isDebugEnabled()) {
LOG.debug("after Locale=" + invocation.getStack().findValue("locale"));
}
if (LOG.isDebugEnabled()) {
LOG.debug("intercept } ");
}
return result;
}
|
protected void saveLocale(ActionInvocation invocation,
Locale locale) {
invocation.getInvocationContext().setLocale(locale);
}
Save the given locale to the ActionInvocation. |
public void setAttributeName(String attributeName) {
this.attributeName = attributeName;
}
|
public void setParameterName(String parameterName) {
this.parameterName = parameterName;
}
|